"""
File containing functions for HPC computing, distributed tasks on clusters etc.

Mainly divided in 2 sections: Slurm and Condor
"""

import os
import time

class slurm_grid():
    



def create_directories_hpc(working_dir):
    """
    Function to create a set of directories, given a root directory
    
    These directories will contain stuff for the HPC runs
    """

    # 
    if not os.path.exist(working_dir):
        print("Error. Working directory {} does not exist! Aborting")
        raise ValueError

    directories_list = ['scripts','stdout','stderr','results','logs','status','joining']

    # 
    for subdir in directories_list:
        full_path = os.path.join(working_dir, subdir)
        os.makedirs(full_path, exist_ok=False)

    # Since the directories are probably made on some mount which has to go over NFS
    # we should explicitly check if they are created

    print("Waiting for directories")
    directories_exist = False
    while directories_exist:
        directories_exist = True

        for subdir in directories_list:
            full_path = os.path.join(working_dir, subdir)

            if not os.path.exist(full_path):
                time.sleep(1)
                directories_exist = False

    print("Directories exist")



